Grape (groovy 2.5.0 API)
Date: 2018-05-27

Package: groovy.grape

## [Java] Class Grape

- groovy.grape.Grape

- Facade to GrapeEngine.

- - ### Field Summary

    Fields
    Modifiers | Name | Description
    --- | --- | ---
    `static String` | `AUTO_DOWNLOAD_SETTING` |
    `static String` | `DISABLE_CHECKSUMS_SETTING` |
    `static String` | `SYSTEM_PROPERTIES_SETTING` |
    `protected static GrapeEngine` | `instance` |

  - ### Methods Summary

    Methods
    Type Params | Return Type | Name and description
    --- | --- | ---
    `` | `static void` | `addResolver(Map<String, Object> args)`
    `` | `static Map<String, Map<String, List<String>>>` | `enumerateGrapes()`
    `` | `static boolean` | `getDisableChecksums()` Global flag to ignore checksums.
    `` | `static boolean` | `getEnableAutoDownload()` This is a static access auto download enabler.
    `` | `static boolean` | `getEnableGrapes()` This is a static access kill-switch.
    `` | `static GrapeEngine` | `getInstance()`
    `` | `static void` | `grab(String endorsed)`
    `` | `static void` | `grab(Map<String, Object> dependency)`
    `` | `static void` | `grab(Map<String, Object> args, Map... dependencies)`
    `` | `static Map[]` | `listDependencies(ClassLoader cl)`
    `` | `static URI[]` | `resolve(Map<String, Object> args, Map... dependencies)`
    `` | `static URI[]` | `resolve(Map<String, Object> args, List depsInfo, Map... dependencies)`
    `` | `static void` | `setDisableChecksums(boolean disableChecksums)` Set global flag to ignore checksums.
    `` | `static void` | `setEnableAutoDownload(boolean enableAutoDownload)` This is a static access auto download enabler.
    `` | `static void` | `setEnableGrapes(boolean enableGrapes)` This is a static access kill-switch.

  - ### Inherited Methods Summary

    Inherited Methods
    Methods inherited from class | Name
    --- | ---
    `class Object` | `wait, wait, wait, equals, toString, hashCode, getClass, notify, notifyAll`

- - ### Field Detail

    - #### public static final String AUTO_DOWNLOAD_SETTING

    - #### public static final String DISABLE_CHECKSUMS_SETTING

    - #### public static final String SYSTEM_PROPERTIES_SETTING

    - #### protected static GrapeEngine instance

  - ### Method Detail

    - #### public static void addResolver(Map<String, Object> args)

    - #### public static Map<String, Map<String, List<String>>> enumerateGrapes()

    - #### public static boolean getDisableChecksums()

      Global flag to ignore checksums. By default it is set to false.

    - #### public static boolean getEnableAutoDownload()

      This is a static access auto download enabler. It will set the 'autoDownload' value to the passed in arguments map if not already set. If 'autoDownload' is set the value will not be adjusted.

      This applies to the grab and resolve calls.

      If it is set to false, only previously downloaded grapes will be used. This may cause failure in the grape call if the library has not yet been downloaded

      If it is set to true, then any jars not already downloaded will automatically be downloaded. Also, any versions expressed as a range will be checked for new versions and downloaded (with dependencies) if found.

      By default it is set to true.

    - #### public static boolean getEnableGrapes()

      This is a static access kill-switch. All of the static shortcut methods in this class will not work if this property is set to false. By default it is set to true.

    - #### public static GrapeEngine getInstance()

    - #### public static void grab(String endorsed)

    - #### public static void grab(Map<String, Object> dependency)

    - #### public static void grab(Map<String, Object> args, Map... dependencies)

    - #### public static Map[] listDependencies(ClassLoader cl)

    - #### public static URI[] resolve(Map<String, Object> args, Map... dependencies)

    - #### public static URI[] resolve(Map<String, Object> args, List depsInfo, Map... dependencies)

    - #### public static void setDisableChecksums(boolean disableChecksums)

      Set global flag to ignore checksums. By default it is set to false.

    - #### public static void setEnableAutoDownload(boolean enableAutoDownload)

      This is a static access auto download enabler. It will set the 'autoDownload' value to the passed in arguments map if not already set. If 'autoDownload' is set the value will not be adjusted.

      This applies to the grab and resolve calls.

      If it is set to false, only previously downloaded grapes will be used. This may cause failure in the grape call if the library has not yet been downloaded.

      If it is set to true, then any jars not already downloaded will automatically be downloaded. Also, any versions expressed as a range will be checked for new versions and downloaded (with dependencies) if found. By default it is set to true.

    - #### public static void setEnableGrapes(boolean enableGrapes)

      This is a static access kill-switch. All of the static shortcut methods in this class will not work if this property is set to false. By default it is set to true.